package org.snap.dresources;

import java.io.Serializable;
import java.util.*;
import dermi.core.*;

public class ResourcesElem implements Serializable{
	static final long serialVersionUID = 873923479;
	
	public enum ElemType {FILE, FOLDER};
	
	private Hashtable<String,ResourcesElem> elems;
	private ElemType type;
	private Id hash;
	private String storage;
	
	public ResourcesElem(ElemType type, Id hash, String storageName)
	{ 
		this.type = type;
		if(type==ElemType.FILE){
			this.elems = null;
			this.hash = hash;
			this.storage = storageName;
		}else if(type==ElemType.FOLDER){
			this.elems = new Hashtable<String,ResourcesElem>();
			this.hash = null;
			this.storage = null;
		}
	}

	public void addResource(String name, ElemType ntype, Id hash, String storageName) throws ResourcesException{
		if( type != ElemType.FOLDER ) {
			throw new ResourcesException("Imposible to add new resources to a file");
		}else{
			elems.put(name, new ResourcesElem(ntype, hash, storageName));
		}
	}
	
	public Id getId() {
		return hash;
	}
	
	public String getFileName() {
		return storage;
	}
	
	public Hashtable getElems() {
		return elems;
	}

	public ElemType getType() {
		return type;
	}
}